Copyright: Copyright (c) 1982-1997 Borland International, Inc.


Configuration page

The Configuration page lets you add and configure ODBC drivers, configure other standard and SQL drivers, and configure the Borland Database Engine (BDE). To view the Configuration page, click the Configuration tab in the left pane of the BDE Administrator.

You can view and edit current settings on the Definition page in the right pane.

For more information on configuring drivers, configuring BDE, and interpreting information in the left and right panes of the BDE Administrator, click a button below. For information about saving configuration settings, see Saving configuration information.

Note:	Before using this page to change your BDE configuration file, be sure to close any open BDE applications. Your changes take effect the next time you start your Borland Database Engine application.

 Driver configuration topics

 BDE system configuration topics

 BDE Administrator user interface

 Other BDE online documentation


Saving configuration information

To save configuration information, choose Object|Apply or click the Apply button.

The Configuration page of the BDE Administrator can store BDE configuration information in either or both of two places:

in the Windows Registry
The Registry includes all driver information, the size of the Swap Buffer (Database Data cache) and various other system information.

in the default BDE configuration file (IDAPI32.CFG)
The configuration file always contains database aliases and the Paradox NET DIR entry (in the Paradox section). If saved in the Windows 3.1 compatible format (composite 16-/32-bit), it may duplicate some of the System and Driver entries.

Where and how BDE configuration information is stored depends on what you check in the Options dialog box.

The changes take effect the next time you re-start all open BDE applications.

To save current settings in a file other than IDAPI32.CFG, choose Object|Save As Configuration.

 Other BDE configuration topics


Configuring Microsoft Open Database Connectivity (ODBC)

The easiest way to configure ODBC is to:

1.	Highlight ODBC under Drivers on the Configuration page of the BDE Administrator or highlight an ODBC database on the Databases page.

2.	Choose Object|Vendor Configuration. For ODBC 2.x drivers, the ODBC Administrator appears. For ODBC 3.x drivers, the Data Sources dialog box appears. Follow the onscreen instructions and vendor-supplied Help.

Manual configuration

Or, you can configure ODBC manually, as described in this section.

The following topics contain sample configuration file blocks to help you understand the procedure for configuring ODBC. First configure the ODBC configuration file, then configure the BDE configuration file to support ODBC.

Configuring the ODBC configuration file

Configuring the BDE configuration file for ODBC

ODBC Socket configuration entries

AutoODBC

 Driver configuration topics

 Other BDE configuration topics


Configuring the ODBC configuration file

Two files contain the configuration information for ODBC:

The Windows Registry lists the ODBC drivers.

The file ODBC.INI lists the ODBC data sources.

Use the administrative program ODBCADMIN to modify these files.To launch this program, choose Object|Vendor Configuration from any ODBC driver or alias.

The files are ASCII, but direct user editing is not recommended.

Here is a sample ODBC.INI file:

[ODBC Data Sources]

   My Oracle7=VENDOR Oracle7

   [My Oracle7]

   Driver=C:\windows\system\OR706.DLL

   Description=ODBC Oracle7 Driver

   ServerName=X:ZAPPA

   Servers=

   LogonID=guest

   LockTimeOut=

   ArraySize=

   QEWSD=34480

The first block [ODBC Data Sources] lists the ODBC data sources and their associated drivers. Then, for each data source, there is a block that describes the datasource. One data source [My Oracle7] is shown in the example above.

Here is a sample ODBCINST.INI file (the file that describes the drivers):

[ODBC Drivers]

   VENDOR Oracle7=Installed

[VENDOR Oracle7]

   Driver=C:\ODBC\OR706.DLL

   Setup=C:\ODBC\OR706.DLL

   APILevel=1

   ConnectFunctions=YYY

   DriverODBCVer=02.01

   FileUsage=0

   SQLLevel=1

The first block [ODBC Drivers] lists the installed drivers. The second block is the configuration block for the first installed drivers.

Each datasource in the ODBC.INI file will have an installed driver (for example, VENDOR Oracle7) in the ODBCINST.INI file.

 Other BDE configuration topics

 ODBC configuration


Configuring the BDE configuration file for ODBC

The configuration of BDE (at least as it relates to SQL) is similar to the ODBC configuration. You must specify a series of DRIVERS (like the ODBC drivers) and ALIASES (much like the ODBC data sources).

Here is an example showing a Drivers section from the Registry:

ORACLE:

INIT:

VERSION:4.0

TYPE:SERVER

DLL:SQLD_ORA.DLL

DLL32:SQLORA32.DLL

VENDOR INIT:NULL

DRIVER FLAGS:NULL

TRACE MODE=0

DB OPEN:

SERVER NAME:ORA_SERVER

USER NAME:MYNAME

NET PROTOCOL:MYNET PROTOCOL

OPEN MODE:READ/WRITE

SCHEMA CACHE SIZE:8

LANGDRIVER:NULL

SQLQRYMODE:NULL

SQLPASSTHRU MODE: SHARED AUTOCOMMIT

SCHEMA CACHE TIME: -1

MAXROWS: -1

BATCH COUNT: 200

Note that it is this entry ORACLE that gets associated with the aforementioned alias reference to a driver.

Here is an example of a Database Alias section of a BDE configuration file (IDAPI.CFG):

ORACLE7:

DB INFO:

TYPE:ORACLE

PATH:NULL

DB OPEN:

SERVER NAME: ORA_SERVER

USER NAME:MYNAME

NET PROTOCOL:MY NET PROTOCOL

OPEN MODE:READ/WRITE

SCHEMA CACHE SIZE:32

LANGDRIVER:NULL

SQLQRYMODE:NULL

SQLPASSTHRU MODE:NOT SHARED

SCHEMA CACHE TIME:-1

MAXROWS: -1

BATCH COUNT: 200

There are two sub-properties:

INFO. The INFO information is used to associate the alias with the correct driver name (see TYPE: ORACLE).

OPEN. The OPEN information is used to open the database alias.

 Other BDE configuration topics

 ODBC configuration


ODBC Socket configuration entries

This example shows a Drivers section from the BDE section of the Registry. This section was added manually with the BDE Administrator.

      ODBC_ORA7:

INIT:

VERSION:4.0

TYPE:SERVER

DLL:IDODBC01.DLL

DLL32: IDODBC32.DLL

ODBC DRIVER:VENDOR Oracle7

DRIVER FLAGS:NULL

DB OPEN:

USER NAME:guest

ODBC DSN:My Oracle7

OPEN MODE:READ/WRITE

SCHEMA CACHE SIZE:8

SQLQRYMODE:NULL

LANGDRIVER:NULL

SQLPASSTHRU MODE:NULL

Note that the DLL field for the driver is the ODBC socket .dll, NOT the ODBC .dll. The ODBC .dll is loaded implicitly, when the ODBC socket attempts to connect to a data source. The data source that it tries to open is "My Oracle7" (the DSN entry).

The following example shows a Database Alias section from the BDE configuration file (IDAPI.CFG). This section was added manually with the BDE Administrator (BDEADMIN.EXE).

ODBC_ORACLE:

DB INFO:

TYPE:ODBC_ORA7

PATH:NULL

DB OPEN:

USER NAME:guest

ODBC DSN:My Oracle7

OPEN MODE:READ/WRITE

SCHEMA CACHE SIZE:8

SQLQRYMODE:NULL

LANGDRIVER:NULL

SQLPASSTHRU MODE:SHARED AUTOCOMMIT

 Other BDE configuration topics

 ODBC configuration


AutoODBC

AutoODBC builds the ODBC socket datasource and driver names automatically for BDE upon BDE initialization, using the ODBC names from the ODBC configuration files, ODBC.INI and ODBCINST.INI. (Note: Using AutoODBC may not be necessary because of the Virtual configuration mode setting. For more information, see Options dialog box.)

Here is an example showing the Registry entries created by AutoODBC referring to the driver (VENDOR Oracle7) and datasource (My Oracle7):

My Oracle7:

DB INFO:

TYPE:VENDOR Oracle7

PATH:NULL

DB OPEN:

USER NAME:guest

ODBC DSN:My Oracle7

OPEN MODE:READ/WRITE

SCHEMA CACHE SIZE:8

SQLQRYMODE:NULL

SQLPASSTHRU MODE:SHARED AUTOCOMMIT

VENDOR Oracle7:

INIT:

VERSION:4.0

TYPE:SERVER

DLL:IDODBC01.DLL

DLL32:IDODBC32.DLL

ODBC DRIVER:VENDOR Oracle7

DRIVER FLAGS:NULL

DB OPEN:

USER NAME:NULL

ODBC DSN:My Oracle7

OPEN MODE:READ/WRITE

SCHEMA CACHE SIZE:8

SQLQRYMODE:NULL

LANGDRIVER:NULL

SQLPASSTHRU MODE:NULL

 Other BDE configuration topics

 ODBC configuration


System INIT settings

The System INIT settings are the settings the BDE uses to start an application. This information is stored in the Windows Registry.

To display these settings:

1.	Click the Configuration tab in the left pane and expand Configuration in the settings tree.

2.	Expand System in the tree.

3.	Expand INIT in the tree.

The settings appear on the Definition tab in the right pane.

In the following table, Parameter lists all the configurable system and network parameters, with their current values. When your BDE application is first installed, all values are set to their defaults.

Description briefly notes the purpose of the selected parameter.

To change a setting, highlight the desired parameter. Then replace its old value with a new value. When edits are complete, choose Object|Apply or click the Apply button to save the changes.

Parameter	Description

VERSION	An internal setting that describes the current version of the BDE. Do not modify.

LOCAL SHARE	The ability to share access to local data between an active BDE application and an active non-BDE application. Set to TRUE if you need to work with the same files through both a BDE and a non-BDE application at the same time. (It is not necessary to set LOCAL SHARE to TRUE if you do not need to have both applications open at the same time.) Default: FALSE

MINBUFSIZE	Minimum amount of memory for database data cache, in kilobytes. Can be any integer between 32 and 65535. Must be less than the total amount of RAM available to Windows. Default: 128

MAXBUFSIZE	Maximum amount of memory for database data cache, in kilobytes. Can be any integer greater than MINBUFSIZE and less than (or equal to) the total amount of RAM available to Windows. Must be a multiple of 128. Default: 2048

LANGDRIVER	System language driver that defaults to the OEM driver appropriate for a country's version of Windows; for example, 'ascii' ANSI (DBWINUS0) for US workstations.

MAXFILEHANDLES	Maximum number of file handles the BDE uses. Can be any integer ranging from 5 to 4096. High values improve performance but use more Windows resources. Default: 48

SYSFLAGS	Internal BDE setting. Do not modify.

LOW MEMORY

USAGE LIMIT	Maximum amount of low memory the BDE will attempt to use, in kilobytes.
Default: 32.

AUTO ODBC	Set to TRUE to import installed ODBC drivers and datasources every time BDE is initialized. Default: FALSE.
Note: Setting AUTO ODBC to TRUE is no longer recommended because of the Virtual configuration mode setting. For more information, see Options dialog box.

DEFAULT DRIVER	Driver first tried when TYPE is FILE and the table name has no extension.

SQLQRYMODE	Method for handling queries to SQL data. Can be NULL, SERVER, or LOCAL. The SQLQRYMODE parameter appears only if a Borland SQL Link driver is installed. Default: NULL

MEMSIZE	Maximum amount of memory that BDE will use, in megabytes. Default: 16 MB.

SHAREDMEMSIZE	Maximum amount of memory BDE will use for shared resources, in kilobytes. Default: 2048 KB. Minimum: 2048 KB. If a value below 2048 is specified, 2048 will be used. File handles, drivers, and system, client and table objects are shared resources and SHAREDMEMSIZE should be increased when using many of these objects.

SHAREDMEMLOCATION	Preferred address of shared memory manager. The shared memory manager and shared buffer manager load at a preferred address. If this address is used, the system can find a suitable address (first process only). If this address conflicts with another application, you might want to modify it. If the shared managers cannot be loaded into the default, or specified memory address, one attempt to allow the operating system to find a memory address is made. If a memory address if specified outside the boundry (below), the default is used.

Default (for Windows 95): 0xEBDE0000

Minimum Value (for Windows 95): 0x90000000

Maximum Value (for Windows 95): 0xFFFF0000

Default (for Windows NT): 0x6BDE0000

Minimum Value (for Windows NT): 0x10000000

Maximum Value (for Windows NT): 0x7F000000

DATA REPOSITORY	The name of the active data dictionary.


System Format Date settings
System Formats Date settings

The System Formats Date settings specify how to convert string values into date values.

To display these settings:

1.	Click the Configuration tab in the left pane and expand Configuration in the settings tree.

2.	Expand System in the tree.

3.	Expand Formats in the tree.

4.	Choose Date in the tree.

The settings appear on the Definition tab in the right pane.

In the following table, Parameter lists all the configurable date parameters, with their current values. When your BDE application is first installed, all values are set to their defaults.

Description briefly notes the purpose of the selected parameter.

To change a setting, highlight the desired parameter. Then replace its old value with a new value. When edits are complete, choose Object|Apply or click the Apply button to save the changes.

Parameter	Description

SEPARATOR	Character used to separate the month, day, and year components of a date value; such as, the "/" in "12/31/96." The default is the character normally used in the country selected in the Windows Control Panel when any BDE application is installed.

MODE	Controls the order of the month, day, and year components and can be 0 (for MDY), 1 (for DMY), or 2 (YMD). The default is the order normally used in the country selected in the Windows Control Panel when any BDE application is installed.

FOURDIGITYEAR	Specifies the number of digits for the year value (four or two). If TRUE, years are expressed in four digits (such as, 1996). If FALSE, the default, years have two digits (96).

YEARBIASED	Tells the BDE application whether or not it should add 1900 to years entered as two digits. For example, if TRUE and you enter "7/21/96," the BDE application interprets your value as "7/21/1996", otherwise, the date is interpreted as entered (in this case, "7/21/0096"). Default: TRUE

LEADINGZEROM	Specifies whether or not single digit month values have a leading zero. For example, if you enter "1/1/80" and this is set to TRUE, the BDE application interprets the date as "01/1/80." If FALSE, the value is "1/1/80." Default: FALSE

LEADINGZEROD	Controls whether or not single digit day values have a leading zero. For example, if you enter "1/1/80" and this is set to TRUE, the BDE application interprets the value as "1/01/80." If FALSE, your date is "1/1/80." Default: FALSE


System Format Time settings
System Formats Time settings

The System Formats Time settings specify how to convert string values into time values.

To display these settings:

1.	Click the Configuration tab in the left pane and expand Configuration in the settings tree.

2.	Expand System in the tree.

3.	Expand Formats in the tree.

4.	Choose Time in the tree.

The settings appear on the Definition tab in the right pane.

In the following table, Parameter lists all configurable time format parameters, with their current values. When your BDE application is first installed, all values are set to their defaults.

Description briefly notes the purpose of the selected parameter.

To change a setting, highlight the desired parameter. Then replace its old value with a new value. When edits are complete, choose Object|Apply or click the Apply button to save the changes.

Parameter	Description

TWELVEHOUR	Specifies whether or not BDE applications express time values using a twelve-hour clock. For example, if TRUE 8:21 p.m. is expressed as "08:21 PM;" if FALSE, "20:21." Default: TRUE

AMSTRING	Character string used to indicate morning (before noon and after midnight) times, when TWELVEHOUR is TRUE. Default: AM

PMSTRING	Character string used to indicate evening (after noon and before midnight) times, when TWELVEHOUR is TRUE. Default: PM

SECONDS	Specifies whether or not time values include seconds. For example, if TRUE, 8:21:35 p.m. is expressed as "8:21:35 PM;" if FALSE, "8:21 PM." Default: TRUE

MILSECONDS	Specifies whether or not time values include milliseconds. For example, if TRUE, "8:21:35:54 PM." Default: FALSE


System Format Number settings
System Formats Number settings

The System Formats Number settings specify how to convert string values to number values.

To display these settings:

1.	Click the Configuration tab in the left pane and expand Configuration in the settings tree.

2.	Expand System in the tree.

3.	Expand Formats in the tree.

4.	Choose Number in the tree.

The settings appear on the Definition tab in the right pane.

Parameter lists all configurable number format parameters, with their current values. When your BDE application is first installed, all values are set to their defaults.

Description briefly notes the purpose of the selected parameter.

To change a setting, highlight the desired parameter. Then replace its old value with a new value. When edits are complete, choose Object|Apply or click the Apply button to save the changes.

Parameter	Description

DECIMALSEPARATOR	Character used to separate the decimal portion of a number from its integer portion; for example, the period (.) in 3.14. Default: The standard decimal separator used for your country, as specified in the Windows Control Panel (International Setting).

THOUSANDSEPARATOR	Character used to separate large numbers into their "thousands" components; for example, the commas (,) in 1,000,000.00. Default: The standard thousands separator used for your country, as specified in the Windows Control Panel (International Setting).

DECIMALDIGITS	Specifies the maximum number of decimal places to be used when converting string values to number values. Default: 2

LEADINGZERON	Indicates whether numbers between 1 and -1 use leading zeros; for example, 0.14. instead of .14. Default: TRUE


Drivers settings

Paradox settings	dBASE settings	ODBC settings

Use the Drivers settings to modify the settings that the BDE uses to determine how an application creates, sorts, and handles tables.

To display these settings:

1.	Click the Configuration tab in the left pane and expand Configuration in the settings tree.

2.	Expand Drivers in the tree. A list of all installed database drivers appears, split into Native and ODBC branches.

3.	Choose the driver name in the tree.

The settings appear on the Definition tab in the right pane.

STANDARD drivers are Paradox, dBASE and FoxPro (dBASE with LEVEL set to 25). A driver for Microsoft Access is also included. Other drivers are installed separately.

To modify a setting, select the driver name and highlight a desired configuration parameter. Delete the old value and enter a new one in the appropriate text box. You can only modify parameters WITHOUT bold labels. When edits are complete, choose Object|Apply or click the Apply button to save the changes.

You can choose Object|New to add a new ODBC driver. Other commands on the Object menu let you administer and remove ODBC drivers.


BDE Administrator error

Read the Error dialog box to determine the source of the error. If you need more help:

1.	Click the Index tab in online Help.

2.	Enter the first few words of the error message you received.

The name of the related help topic appears.

3.	Double-click the topic.

When you are ready, select OK in the error message window and try the operation again.


BDE Administrator: Overview

The BDE Administrator lets you:

Configure the Borland Database Engine (BDE).

Configure STANDARD (Paradox and dBASE/FoxPro), SQL, Access, and ODBC drivers; create and delete ODBC drivers.

Create and maintain database aliases.

 Other BDE Administrator topics


The BDE Administrator window

The BDE Administrator window displays information in two panes.

The left pane is tabbed and displays a hierarchical tree of objects:

Databases page, aliases of available databases.

Configuration page, database drivers and BDE configuration settings.

The right pane contains tabbed pages that display the contents of objects highlighted in the left pane. The tabbed pages in the right pane vary depending on the type of object highlighted in the left pane. For a list, see Tabbed pages.

A plus sign (+) beside an object in the left pane indicates that the object contains other objects below it. To see those objects, click the plus sign. When an object is expanded to show its child objects, the plus sign becomes a minus sign. To hide child objects, click the minus sign. For a list of other graphic symbols in the left pane, see Color-coded symbols.

To view information about an object in the left pane, double-click the object. The right pane displays one or more tabbed pages of information about the object. For example, when a database alias is highlighted in the left pane, the right pane displays a Definition page that contains database Type, PATH, and DRIVER NAME parameters. Bolded parameters indicate a parameter that cannot be modified. All other parameters that appear in the right pane can be edited there.

 BDE Administrator user interface


Color-coded symbols

The following color-coded symbols appear to the left of objects in the left pane:

Icon	Meaning

Green box	The highlighted database is open.

Red arrow	The object is in editing mode. There are changes in this object or in objects further down its tree that have not been applied.

Shining red arrow	The object is newly created.

Red X	This object is to be deleted. When changes to this object or its parent object are applied the object is deleted. To see this symbol, check Confirm Edits on the Options menu. Otherwise, the object will be deleted instantly without a chance to apply the deletion.

Applying edits

Note:	Edits only take effect when they are applied. To apply edits and make changes permanent:

1.	Click a red arrow or shining red arrow icon at the highest level where you want edits applied.

2.	Right-click and choose Apply or click the Apply button [image].

 BDE Administrator user interface


Tabbed pages

The selections you make in the left pane enable the following tabbed page in the right pane:

Right pane pages	Description

Definition	Displays the parameters of the database alias or driver highlighted in the left pane.

You can edit parameters on the Definition page if the parameter names appear in normal type. If parameter names appear in bold, they cannot be edited.

 BDE Administrator user interface


Menu commands

The following topics define the commands available from each menu on the BDE Administrator’s menu bar.

Object menu commands

Edit menu commands

View menu commands

Options menu commands

Help menu commands

 BDE Administrator user interface


Object menu commands

These commands appear on the Object menu. Most of these commands are also available from the context menu that appears when you right-click with an object selected in the BDE Administrator.

Object menu	Description

Open	Open the highlighted object.

Close	Close the highlighted object.

New	Create a new instance of the highlighted object class.

Delete	Delete the highlighted object.

Rename	Change the name of an object.

Apply	Save the highlighted object, including all changes and pending deletes to objects within its tree.

Cancel	Cancel the current operation.

Save As	Save the selected object under another name.

ODBC Administrator	Launch the ODBC Administrator for configuring ODBC drivers.

Vendor Configuration	Launch the appropriate configuration utility for the selected driver or alias.

Version Information	Display version information about BDE and vendor DLLs.

Open Configuration	Open the selected BDE configuration file.

Save As Configuration	Save the current BDE settings under another name.

Merge Configuration	Combine the selected configuration file with the current file.

Options	Set configuration saving options and ODBC driver display options.

Exit	Exit the BDE Administrator.

 Menu commands


Edit menu commands

Edit menu	Description

Undo	Cancels last command or reverts to previous state.

Cut	Copies and removes the selected parameter or field data.

Copy	Copies but does not remove the selected parameter or field data.

Paste	Pastes a cut or copied string into the selected field or at the insertion point in text.

Delete	Deletes the selected text.

Select All	Selects all text in the current edit box.

 Menu commands


View menu commands

View menu	Description

Toolbar	If checked, the toolbar is displayed near the top of the BDE Administrator. The toolbar offers a few convenient icon duplicating the functionality of menubar commands such as Open, Delete, Cancel, Apply.

Status Bar	If checked, a status bar appears at the bottom of the BDE Administrator window. It states how many items are found in the object highlighted in the left pane.

Refresh	If enabled for the currently selected object, Refresh redraws the display of the object and its children.

 Menu commands


Options menu commands

Options menu	Description

Show Confirmations	If checked, a confirm dialog is displayed after performing any modifications.

Show Warnings	If checked, a warning dialog appears whenever data or meta-data would be lost during the current server operation.

 Menu commands


Help menu commands

Help menu	Description

Contents	Displays the WinHelp contents window.

About	Version and copyright information.

 Menu commands


Key commands

You can expand and contract the hierarchy of objects in the left pane with the following keystrokes.

To do this...	Press this key...

Expand object (display child objects)	+ (plus sign) or Right arrow key
Contract object (hide child objects)	- (minus sign) or Left arrow key
Show entire tree (display all levels)	* (asterisk)
 BDE Administrator user interface


Databases page

The Databases page shows aliases of available databases. To view the Databases page, click the Databases tab in the left pane of the BDE Administrator.

You can view and edit current settings on the tabbed pages in the right pane.

For more information on creating and editing database objects and interpreting information in the left and right panes of the BDE Administrator, click a button below.

 Database topics

 BDE Administrator user interface


Working with database aliases

You can use the BDE Administrator to view, create, and modify Borland Database Engine (BDE) aliases. The following table lists each task and briefly describes the steps needed to accomplish it on the Databases page:

Task...	Instructions...

View aliases...	1.	Click the plus sign beside a database object in the left pane to see a list of alias objects.

2. 	Select the alias to view in the left pane. The Definitions page appears in the right pane.

Create an alias...	1.	Select a database object in the left pane.

2.	Right-click to invoke the context menu.

3.	Choose New.

4.	Select a driver in the New Database Alias dialog box and choose OK.

5.	Type a name for the alias in the left pane.

6.	Enter a path for the alias in the PATH or SERVER NAME parameter on the Definitions page in the right pane. Optionally specify a driver in the Default Driver parameter.

7.	Right-click the database object in the left pane to invoke the context menu and choose Apply to create the database.

Modify an alias...	1.	Select the alias to modify in the left pane. The Definitions page appears in the right pane.

2.	Edit the PATH and Default Driver parameters as desired.

3.	Right-click the database object in the left pane to invoke the context menu and choose Apply to update the database.

Delete an alias...	1.	Select the alias to delete in the left pane.

2.	Right-click to invoke the context menu.

3.	Choose Delete to remove the alias.

4.	Right-click the database object to invoke the context menu and choose Apply to update the database.

Note:	If you're creating a new ODBC alias, you must define its DSN before you can connect to that database.

 Database topics

 BDE Administrator user interface


Aliases

An alias is a name and a set of parameters that describe a network resource. BDE applications use aliases to connect with shared databases. An alias is not required to address a local database, but it is required to address an SQL database.


BDE Administrator toolbar

The BDE Administrator toolbar contains the following buttons for executing commands:

Button	Command
Open	Open or close the selected object.
Delete	Delete a selected object.
Cancel	Abandon modifications to a selected object.
Apply	Commit modifications of the selected object.
 BDE Administrator user interface


Definition page

The Definition page in the right pane displays parameters of the object highlighted in the left pane.

If the System tree is expanded, these kinds of parameters appear:

INIT

Formats

Date

Time

Number


Reserved

Reserved for future use.


Save As command

Right-click and choose Save As or Object|Save As to save the selected object under the same or a different name. If you specify a new name, a new object is created and any editing changes are applied to the new object. Edits to the original object remain intact, but are not applied to the original object until you choose to apply them.

When you choose Save As, the Save As dialog box appears.


Save As dialog box

You can use the Save As dialog box to save the selected object under the same or a different name. To display this dialog box, use Save As or Object|Save As.

Dialog box options

New Name

Enter the new name for the object in the edit box. By default, the current name is proposed. Choose OK without changing the name to use it.


Select All command

Right-click and choose Select All or Edit|Select All to select all text in the current edit box or on the Enter SQL or Text page.


About command

Use Help|About to display version and copyright information for Database Explorer or the BDE Administrator (this item does not appear when you invoke the Database Explorer from the Delphi IDE).


Apply command

Right-click and choose Apply or Object|Apply to save the highlighted object, including all changes and pending deletes to objects within its tree.


Cancel command

Right-click and choose Cancel or Object|Cancel to cancel the current operation.


Close command

Right-click and choose Close or Object|Close to close the highlighted object.


Show Confirmations command

Use Options|Show Confirmations to help prevent unwanted changes. If checked, a confirmation dialog is displayed after performing any modifications.


Show Warnings command

Use Options|Show Warnings to toggle the display of warning messages when data loss or meta-data loss can occur while editing.

For example, data loss can occur if a table column is moved; the table will be dropped and the columns recreated in the new order. Meta-data loss can occur if the contents of a view object are altered.

If Show Warnings is checked, warnings occur where appropriate for each object that is operated upon.


Contents command

Use Help|Contents to display the table of contents window for online Help.


Copy command

Right-click and choose Copy or Edit|Copy to put the selected parameter, field data, or text on the Windows Clipboard without removing it.


Cut command

Right-click and choose Cut or Edit|Cut to put the selected parameter, field data, or text on the Windows Clipboard and remove it.


Delete command

Right-click and choose Delete or Object|Delete to remove the highlighted object or text without putting it on the Windows Clipboard.

Right-click and choose Delete or Edit|Delete to remove selected text on the Enter SQL or Text (Database Explorer) pages.

In Database Explorer, use Dictionary|Delete to remove a data dictionary. This command displays the Delete A Dictionary dialog box.


Exit command

Right-click and choose Exit or Object|Exit to close the Database Explorer or BDE Administrator window.


New command

Right-click and choose New or Object|New to create a new instance of the highlighted object class. If the selected object is a database name, the New Database Alias dialog box appears.

In the Database Explorer, use Dictionary|New to create a new data dictionary. This command displays the Create A New Dictionary dialog box.


New Database Alias dialog box

The New Database Alias dialog box is used to select a driver which represents the kind of alias to create.

To display this dialog box, choose Object|New on the Databases page.

Note:	If you're creating a new ODBC alias, you must define its DSN before you can connect to that database.

Dialog box options

Database Driver Name

The driver type of the new alias to created. The default name assigned is the driver name. To enter another name, select the alias, right-click and choose Rename.


Open command

Right-click and choose Open or Object|Open to open the highlighted object.

Open dialog box options

Look In

Displays the current directory. The list below shows the files and folders in that directory.

File Name

Lists the files (*.CFG or *.*) in the current directory.

Files Of Type

Shows the type of files listed in the File Name text box.


Paste command

Right-click and choose Paste or Edit|Paste to paste a cut or copied string into the selected field.

When you right-click in the Enter SQL page in Database Explorer and choose Paste, it copies text from the Windows Clipboard into the current SQL statement.


Refresh command

Right-click and choose Refresh or View|Refresh to redraw the currently selected object and its children.


Rename command

Right-click and choose Rename or Object|Rename to change the name of the selected object. Type the new name over the old.


Status Bar command

Check View|Status Bar to display a status bar appears at the bottom of the Database Explorer or BDE Administrator window. It states how many items are found in the object highlighted in the left pane.


Undo command

You can right-click and choose Undo or Edit|Undo to cancel the last command in the Enter SQL page or revert to the previous state in the active parameter field.


Vendor Configuration command

Note:	This command name is dynamic and is actually the name of the vendor-supplied configuration utility that is appropriate for the selected driver or alias.

Use Vendor Configuration or Object|Vendor Configuration to configure SQL drivers or aliases of the highlighted type. If available, the vendor-supplied configuration utility for that driver type or alias appears. If one is not found, an Open dialog box appears, and you can choose an alternate vendor configuration utility. If you specify an alternate utility, it is saved in the registry under Cfgutils and displayed the next time you highlight a driver or alias of that type and choose Vendor Configuration.

For more information, access Help available through utility dialog boxes.


ODBC Administrator command

Use ODBC Administrator to add, delete, and configure ODBC drivers or data sources. This command appears when you right-click the Databases node on the Databases page or the ODBC node on the Configuration page. It displays the ODBC administration utility provided by your ODBC driver vendor.

For more information, display Help within each administrator dialog box.

Note:	If you add a new ODBC datasource, you must define its DSN before you can connect to that database.


Version Information command

Right-click and choose Version Information or Object|Version Information to display information on installed BDE DLL and driver files as well as configuration DLLs provided by other vendors. This can be useful when solving technical problems.

The Version Information dialog box appears.


Version Information dialog box

This dialog box displays information on installed BDE DLL files and vendor configuration DLLs, if present. Version information can be useful when solving technical problems.

To display this dialog box, choose Version Information or Object|Version Information.

Dialog box options

DLL Name

The name of a DLL file installed as part of the BDE installation or non-standard server installation (such as an SQL server).

Version Number

The version number assigned to that DLL.

Date

The datestamp for that DLL.

Time

The timestamp for that DLL.

Size

The size in bytes of that DLL.


New ODBC Driver dialog box

Use the New ODBC Driver dialog box to add an ODBC driver connection to the Drivers list. Once your ODBC driver connection appears on the Drivers list you can configure an alias for that connection. Your ODBC data source alias enables you to connect to an ODBC database through your BDE application.

To add a new ODBC driver connection:

1.	Click the Configuration tab in the left pane of the BDE Administrator.

2.	Expand Drivers in the tree and click ODBC in the tree. Select Object|New.

3.	In the Driver Name box, enter the name to use for the new driver connection.

4.	Use the drop-down list in the ODBC Driver Name field to identify the ODBC driver for your data source.

5.	Select one or more target ODBC data sources in the Select Data Sources To Create Aliases list. (Note: This step is optional; and helps to auto-create aliases.)

If you cannot find your ODBC driver or your ODBC data source name on the lists provided, they may not be installed properly. You may need to install your ODBC driver or set up your ODBC data source again. For more information click here:
  ODBC configuration

The new ODBC driver is added to the currently active configuration file. To save the new driver in a different configuration file, select Object|Save As Configuration and use the current configuration file name or another one.

Note:	If you're creating a new ODBC alias, you must define its DSN before you can connect to that database.

Dialog box options

Driver Name

The name you want to give to your ODBC driver connection. The following are invalid driver or alias name characters: colon (:) and backslash (\).

ODBC Driver Name

The name of the ODBC driver used to connect to this ODBC data source.

Select Data Sources To Create Aliases

The names of the target ODBC data sources. Select one or more.


Delete ODBC Driver dialog box

Use the Delete ODBC Driver dialog box to remove an ODBC driver connection from the Drivers list.

Highlight the ODBC driver connection you want to delete and select Object|Delete. The BDE Administrator displays the Delete Driver dialog box.

Dialog box options

OK

Select OK to continue deleting.

Cancel

Select Cancel to stop deleting.


Cannot find filename
Cannot find filename. Do you want to search for it yourself?

The application is unable to find the vendor configuration utility. Choose OK to browse for it.


Select Directory dialog box (vendor configuration utility)
Select Directory dialog box

Select the directory where your vendor configuration utility can be found, or other appropriate directory for the parameter you are entering. To close this dialog box without selecting a directory, choose Cancel.


Duplicate driver name
Duplicate driver name.

You tried to give an ODBC driver connection a name already in use for another ODBC driver connection. Each ODBC driver connection in a configuration file should have a unique name.

Click OK in the error message dialog box, then try your entry again.


Invalid configuration file
Invalid configuration file.

The BDE Administrator was unable to open the configuration file you specified. The file may be the wrong type (not a .CFG file), or it may be corrupted or read-only.

Click OK in the error message dialog box, then try your operation again with a different file.


Merge cannot be undone. Continue?

The .CFG file selected in the Open dialog box is about to be merged with the configuration file currently in memory.

Caution! You cannot undo a merge. You might want to first save your current configuration file under another name as a backup.

If so, choose Cancel instead of OK, then choose Object|Save As Configuration to create the backup file.

Dialog box options

OK

To continue merging, choose OK.

Cancel

To cancel the merge operation, choose Cancel.


Merge failed
Merge failed.

The BDE Administrator was unable to merge information from the file you specified into your current configuration file. You may have specified a file that was not a valid configuration file.

Click OK in the error message dialog box, then try your operation again. Be sure to specify a file that ends in .CFG.


Save configuration changes?

You have made changes to the current configuration file, but haven't saved them yet.

Dialog box options

Yes

To save the changes, choose Yes.

No

To close the BDE Administrator or open another configuration file without saving current changes, choose No.


Unable to open configuration file...

The BDE Administrator was unable to open the configuration file you specified because there is another session of this application running or another BDE application running.

Click OK in the error message dialog box, then close all applications or sessions except the current one and try your operation again.


Use filename as default configuration?

You are currently editing a configuration file other than the default. If you want this file to become the new default configuration file, click the Yes button in this dialog box. The configuration data is saved as a 16-bit .cfg file.

Dialog box options

Yes

To make the current file the default, choose Yes. The change takes effect the next time you start your BDE application.

No

To leave the default unchanged, choose No.


Unable to apply new configuration...
Unable to apply new configuration to system.

Another BDE application is open besides the BDE Administrator. Close all other BDE applications, such as Delphi, and try again.


Merge successful.

The requested configuration file was successfully merged with the current configuration file. You can choose Object|Save As Configuration to save the new file under a different name.


Unable to close...
Unable to close current configuration. Operation canceled.

Databases are open, so BDE Administrator cannot close the open configuration file and complete the current operation. Close all open databases and try again.


Reserved

This topic reserved for future use.


ODBC is not installed
ODBC is not installed.

An ODBC dynamic link library (ODBC32.DLL) could not be found.

This .DLL is commonly installed in the recommended locations:

Windows\System

or

odbcsdk\bin

Click OK in the error message dialog box, then check to see if ODBC32.DLL is anywhere on the workstation hard disk. If you find the .DLL in a different directory other than those mentioned above, try moving it to the recommended location. Then try your operation again.

If you continue to have problems, you might need to reinstall ODBC.


Help topic not available
Help topic not available.

The requested Help topic cannot be found.

The requested Help topic may be in a Help file that has not been installed or that has been installed and deleted.

For example, information on SQL drivers is in the Borland SQL Links Help. If you haven't installed Borland SQL Links, you can only view topics on Paradox, dBASE, and ODBC drivers contained in this Help file.


Apply current configuration changes?

You have made driver configuration changes and have not yet saved them. Choose Yes to save them or no to cancel all changes.


Apply current changes to databases?
Apply current configuration changes to databases?

You have made configuration changes to BDE databases. Choose Yes to save the changes or No to cancel the changes.


Save changes to databases?

You have made data changes to BDE databases. Choose Yes to save the changes or No to cancel the changes.


To continue operation...
To continue operation, databases must be closed. Close databases?

Choose OK to continue and close the databases or Cancel to stop the present operation. You will have a chance to save any databases with unsaved changes.


Select Directory dialog box

This setting requires a directory path where specified data can be stored or accessed. Select the directory that defines the required path (the path destination).


Delete all drivername...
Delete all drivername database aliases?

You have deleted a driver type. Do you want to delete all database aliases of that type? Choose Yes to delete the aliases or No to retain them. Note that abandoned aliases will no longer connect without the appropriate driver type.


Please specify driver name.

You have attempted to add a new driver without entering a name. Enter a name and try again.


Toolbar command (BDE Administrator)

If View|Toolbar is checked, the BDE Administrator toolbar appears near the top of the BDE Administrator. The toolbar offers a few convenient icons duplicating the functionality of menubar commands such as Open, Delete, Cancel, and Apply.


This command is not available.

The command you selected is not available in this application.


Open dialog box (Merge Configuration)

Use the Open dialog box to merge another configuration file with the one already in use.

To display this dialog box, choose Merge Configuration or Object|Merge Configuration.

Note:	Merges cannot be undone. It is a good idea to save the current configuration file under another name as a backup before attempting to merge another file with it.

Dialog box options

Look In

Displays the current directory. The list below shows the files and folders in that directory.

File Name

Lists the files (*.CFG) in the current directory.

Files Of Type

Shows the type of files listed in the File Name text box.


Open Configuration command

Right-click and choose Open Configuration or Object|Open Configuration to select a BDE configuration (.CFG) file to view or edit. The Open dialog box (Open Configuration) appears.

To select a .CFG file, use the Look In drop-down list box and Up One Level button beside it to navigate through your system. When you locate the desired file, choose Open to open it.

The in-memory configuration settings are merged from the Registry and the configuration file.  If there are any duplicate entries found in both the Registry and the configuration file, the configuration file has precedence.


Open dialog box (Open Configuration)

Use this dialog box to select a BDE configuration (.CFG) file to view or edit. To display this dialog box, choose Open Configuration or Object|Open Configuration.

Dialog box options

Look In

Displays the current directory. The list below shows the files and folders in that directory.

File Name

Lists the files (*.CFG) in the current directory.

Files Of Type

Shows the type of files listed in the File Name text box.


Save As Configuration command

Choose Save As Configuration or Object|Save As Configuration to save current configuration settings to the default configuration file or a different file. The Save As dialog box appears.

To select a .CFG file name or directory location, use the Look In drop-down list box and Up One Level button beside it to navigate through your system. When you locate the desired name and/or directory, choose Save to save the file with the name listed in the File Name box.

If the selected file is not the default configuration file, the BDE Administrator prompts you to save it as the default when you exit.

You can use the Save Option command to determine whether the configuration file is saved in Windows 95/NT format or a composite format to provide backward compatibility with Windows 3.1 applications. For more information, see Saving configuration information.

Note:	You only need to use this command if you want to save current settings to a configuration file other than the default file. When you choose Object|Apply, all changes are saved to the default configuration file.


Save As dialog box

The Save As dialog box saves all current settings to the default configuration file or another file. To display this dialog box, choose Save As Configuration or Object|Save As Configuration.

Dialog box options

Look In

Displays the current directory. The list below shows the files and folders in that directory.

File Name

Lists the files (*.CFG) in the current directory.

You can name the configuration file anything provided that it:

ends in ".CFG"; and

is no more than 255 characters long, including spaces; and

does not contain the characters:
 \   /   :   *   ?   "   <   >   |

Files Of Type

Shows the type of files listed in the File Name text box.


Default configuration file

The configuration file used at application startup. The default configuration file is listed in the Windows Registry as CONFIGFILE01.

For example:

HKEY_LOCAL_MACHINE/ SOFTWARE/ BORLAND/

 DATABASE ENGINE/CONFIGFILE01

You can name your configuration file anything provided that it:

ends in ".CFG"; and

is no more than 255 characters long, including spaces; and

does not contain the characters:
 \   /   :   *   ?   "   <   >   |


Merge Configuration command

Right-click and choose Merge Configuration or Object|Merge Configuration to merge another configuration file with the one already in use. The BDE Administrator displays the Open dialog box.

To select a .CFG file name or directory location, use the Look In drop-down list box and Up One Level button beside it to navigate through your system. When you locate the desired name and/or directory, choose Open to merge the selected file with the configuration file currently open in memory.

The BDE Administrator prompts whether or not to continue the merge. Choose OK to continue or Cancel to cancel the operation.

Note:	Merges cannot be undone. It is a good idea to save the current configuration file under another name as a backup before attempting to merge another file with it.


Options command

Right-click and choose Options or Object|Options to indicate:

The kind of configuration file to create, a composite 16-/32-bit format to provide backward compatibility with BDE applications for Windows 3.1 or a 32-bit format for use with Windows 95 and Windows NT only.

Which types of ODBC drivers and data sources to display.

When you use this command, the Options dialog box appears.


Options dialog box

Use the Options dialog box to indicate:

The kind of configuration file to create, a composite 16-/32-bit format to provide backward compatibility with BDE applications for Windows 3.1 or a 32-bit format for use with Windows 95 and Windows NT only.

Which types of ODBC drivers and data sources to display.

To display this dialog box, choose Options or Object|Options.

Dialog box options

Save For Use With

Indicates the kind of configuration file to create.

Windows 3.1 And Windows 95/NT

When checked, new and edited configuration files are saved in a combination 16-bit/32-bit format that can be used by both Windows 3.1 and Windows 95 or Windows NT applications.

Any System and Driver settings existing in the current configuration file are written to the new configuration file.

All remaining System and Driver settings are written to the Registry.  Entries are saved from their point of origin.

Database settings are saved to the new configuration file.

NET DIR is saved to the new configuration file.

Windows 95/NT Only

When checked, the new or modified configuration file is only usable by 32-bit applications.

System and Driver settings are saved to the Registry.  The Registry is always updated if the configuration file is the default.

NOTE: If the IDAPI.CFG file is not the default, the file MUST be saved as a composite 16-/32-bit file.

Database settings are saved to the new configuration file.

NET DIR is saved to the new configuration file.

Select Configuration Modes To View

Indicates which ODBC drivers and data sources to display: those created just for this session, only those administered by BDE, and/or all installed on the system. Since these are check boxes, you can choose any or all. In the case of objects with the same name, Session overrides Persistent and Persistent overrides Virtual. Note: These settings are stored in the Registry in the ViewMode key under Borland, Database Engine.

Session

When checked, the tree in the left pane shows ODBC drivers and data sources that are created "on the fly" through program code for just this session.

Persistent

When checked, the tree in the left pane shows ODBC drivers and data sources that are used with BDE applications and configured with the BDE Administrator. If Persistent is unchecked, users won't see a tree view for Native and ODBC drivers and their aliases in the BDE Administrator. Only System INIT information will appear.

Virtual

When checked, the tree in the left pane shows all ODBC drivers and data sources installed on the system, whether or not they are used with BDE applications and configured with the BDE Administrator. Virtual data sources cannot be deleted or renamed. Virtual data sources are administered with the ODBC Administrator supplied by the vendor and appear in BDE with default parameters. If you configure a virtual data source in BDE, it becomes persistent and is then stored in the BDE configuration file. Note: When an ODBC driver or data source changes from virtual to persistent with Persistent checked and Virtual unchecked, the driver won't appear in the tree until you choose View|Refresh.


STANDARD alias settings

When you create an alias on the Databases page, you can choose STANDARD to use one of these driver types:

PARADOX	Paradox, for .DB tables

DBASE	dBASE and FoxPro, for .DBF tables

ASCIIDRV	ASCII text, for .TXT tables

To change a setting, highlight the desired configuration parameter. Delete the old value and enter a new one in the appropriate text box. You can only change parameters WITHOUT bold labels.

In the following table, Parameters lists all tracked parameters for the selected driver type, and their current settings. When the driver is first installed, all values are set to their defaults.

Description briefly notes the purpose of the highlighted parameter.

Parameter	Description

TYPE	Type of database to which this driver helps you connect, STANDARD.

PATH	The path to the target database.

DEFAULT DRIVER	The type of file to access (see list above to jump to descriptions): PARADOX, DBASE, ASCIIDRV.

ENABLE BCD	Specifies whether BDE translates numeric and decimal fields into floating point values or binary coded decimal (BCD) values. BCD values eliminate the rounding errors associated with floating point math (such as a 3 * (2/3) resulting in 2.00000000001). When ENABLE BCD is set to TRUE, DECIMAL and NUMERIC fields are converted to BCD.


Access driver settings

Applications that use BDE can now open or create Microsoft Access tables using the MSACCESS driver.To work with Access tables, choose MSACCESS as the driver name on the Configuration page of BDE Administrator and highlight the desired configuration parameter, or create or select an alias on the Databases page that uses MSACESS as the driver name. Delete the old value and enter a new one in the appropriate text box. You can only change parameters WITHOUT bold labels.

In the following table, Parameters lists all tracked parameters for the selected driver type, and their current settings. When the driver is first installed, all values are set to their defaults.

Description briefly notes the purpose of the highlighted parameter.

Parameter	Description

VERSION	Internal version number of the Access driver.

TYPE	Type of server to which this driver helps you connect. Can be SERVER (SQL server) or FILE (standard, file-based server).

DLL32	The name of the driver's 32-bit Dynamic Link Library (*.DLL). Default: IDDAO32.DLL

DRIVER FLAGS	Internal product-specific flag. Do not change without direct instructions from Borland support personnel.

TRACE MODE	A numeric value (bit mask) specifying how much trace information to log. The Windows OutputDebugString call is used to output the requested information to the debug window. The following table shows which information is logged based on bit settings:

Bit Settings	Logged Information

0x0001	prepared query statement

0x0002	executed query statements

0x0004	vendor errors

0x0008	statement options (that is: allocate, free)

0x0010	connect / disconnect

0x0020	transaction

0x0040	BLOB I/O

0x0080	miscellaneous

0x0100	vendor calls

DATABASE NAME	The drive, path, and .MDB file name to access.

USER NAME	Default name for accessing the database.

OPEN MODE	Mode in which the driver connection opens the database. Can be READ/WRITE or READ ONLY. Default: READ/WRITE

LANGDRIVER	Language driver used to determine table sort order and character set.


Paradox driver settings

To configure the way Paradox tables are created, sorted, and handled, choose Paradox as the driver name on the Configuration page of the BDE Administrator or create or select a STANDARD alias on the Databases page that uses Paradox as the Default Driver.

To change a setting, highlight the desired configuration parameter. Delete the old value and enter a new one in the appropriate text box. You can only change parameters WITHOUT bold labels.

In the following table, Parameters lists all tracked parameters for the selected driver type, and their current settings. When the driver is first installed, all values are set to their defaults.

Description briefly notes the purpose of the highlighted parameter.

Parameter	Description

VERSION	Internal version number of the Paradox driver.

TYPE	Type of server to which this driver helps you connect. Can be SERVER (SQL server) or FILE (standard, file-based server).

NET DIR	The directory location of the Paradox network control file PDOXUSRS.NET. The active NET DIR parameter is stored in the Paradox section of the BDE configuration file and has precedence over any other NET DIR parameters that may be stored in older 16-bit configuration files, or in the System Init section of the current configuration file, or in the Registry.  These other NET DIR entries will have no effect. To access a Paradox table on a network drive, the active NETDIR parameter in the Paradox section of the BDE configuration file must point to a network drive.

LANGDRIVER	Language driver used to determine table sort order and character set. [available drivers].
US default: 'ascii' ANSI (DBWINUS0)

LEVEL	Type of table format used to create temporary Paradox tables.

Level 7 	Paradox for Windows 32-bit tables

Level 5	Paradox 5.0 tables

Level 4	STANDARD table format introduced in Paradox 4.0

Level 3	Compatible table format used by Paradox 3.5 and earlier versions.

Default:	Level 4.

To use Blob fields, secondary indexes, and strict referential integrity, specify either Paradox level 4 or Paradox level 5 tables. You will probably want to use the lowest level possible in order to maximize backward compatibility. Choose Level 7 only If you need the advanced indexing features supported by that table format.

BLOCK SIZE	Size of disk blocks used to store Paradox table records, in multiples of 1024 bytes. Valid settings depend on the table format:

Level 5 and 7 	1024, 2048, 4096, 16384, and 32768

Level 3 and 4	1024, 2048, and 4096

Default:	2048

FILL FACTOR	Percentage of current disk block which must be filled before Paradox will allocate another disk block for index files. Can be any integer ranging from 1 to 100. Default: 95

Note:	Smaller values offer better performance but increase the size of indexes. Larger values give smaller index files but increase the time needed to create an index.

STRICTINTEGRTY	Specifies whether Paradox tables can be modified using applications that do not support referential integrity (such as, Paradox 4.0). For example, if TRUE you will be unable to change a table with referential integrity using Paradox 4.0; if FALSE, you can change the table, but you risk the integrity of your data. Default: TRUE.


dBASE and FoxPro driver settings

To configure the way dBASE and FoxPro tables are created, sorted, and handled, choose dBASE as the driver name on the Configuration page of the BDE Administrator or create or select a STANDARD alias on the Databases page that uses DBASE as the Default Driver type.

To change a setting, highlight the desired configuration parameter. Delete the old value and enter a new one in the appropriate text box. You can only change parameters WITHOUT bold labels.

Since FoxPro is an xBASE application, its driver settings are virtually identical to dBASE's except that LEVEL must be set to 25 to read and write a .DBF table in FoxPro format.

In the following table, Parameters lists all tracked parameters for the selected driver type, and their current settings. When the driver is first installed, all values are set to their defaults.

Description briefly notes the purpose of the highlighted parameter.

Parameter	Description

VERSION	Internal version number of the dBASE driver.

TYPE	Type of server to which this driver helps you connect. Can be SERVER (SQL server) or FILE (standard, file-based server).

LANGDRIVER	Language driver used to determine table sort order and character set. [available drivers]  US. Default: 'ascii' ANSI (DBWINUS0)

LEVEL	Type of table format used to create dBASE temporary tables. Can be 5 for dBASE 5.0 table format, 4 for dBASE 4.0 table format, or 3 for dBASE III and dBASE III PLUS table formats. Use 25 for FoxPro. Default: 5

MDX BLOCK SIZE	Size of disk blocks dBASE allocates for .MDX files, in bytes. Can be any integer that is a multiple of 512. Default: 1024

MEMO FILE BLOCK SIZE	Size of disk blocks dBASE allocates for memo (.DBT) files, in bytes. Can be any integer that is a multiple of 512. Default: 1024


ODBC driver connection settings

To configure the way tables in an ODBC data source are created, sorted, and handled, choose an ODBC driver connection as the driver name on the Configuration page of the BDE Administrator or create or select an alias on the Databases page that uses an ODBC driver.

To change a setting, highlight the desired configuration parameter. Delete the old value and enter a new one in the appropriate text box. You can only change parameters WITHOUT bold labels.

In the following table, Parameters lists all tracked parameters for the selected driver type, and their current settings. When the driver is first installed, all values are set to their defaults.

Description briefly notes the purpose of the highlighted parameter.

Parameter	Description

VERSION	Internal version number of the ODBC driver. Do not modify.

TYPE	For drivers, this parameter is Server. It is uneditable.

For aliases, this parameter uniquely identifies this ODBC driver connection. Can include any combination of alphanumeric characters except : and \.

DLL	The name of the driver's 16-bit Dynamic Link Library (*.DLL). Default: IDODBC16.DLL

DLL32	The name of the driver's 32-bit Dynamic Link Library (*.DLL). Default: IDODBC32.DLL

ODBC DRIVER	The ODBC driver used to connect the workstation to the target ODBC server.

DRIVER FLAGS	Internal product-specific flag. Do not change without direct instructions from Borland support personnel.

DATABASE NAME	The drive, path, and file name to access.

USER NAME	Default name for accessing the ODBC server.

ODBC DSN	The name of the ODBC data source to which this alias will connect. Must be the same as the ODBC data source you named when you created the ODBC driver connection.

OPEN MODE	Mode in which the ODBC driver connection opens the database. Can be READ/WRITE or READ ONLY. Default: READ/WRITE

LANGDRIVER	Language driver used to determine table sort order and character set.

SCHEMA CACHE SIZE	Number of SQL tables whose schema information will be cached. Can be any whole number from 0 to 32. Default: 8

SCHEMA CACHE DIR	Specifies the directory in which the local schema cache is stored. Used when ENABLE SCHEMA CACHE is TRUE to cache schema locally when tables reside on an SQL server.

SQLQRYMODE	Method for handling queries to SQL data. Can be NULL (blank setting), SERVER, or LOCAL. [more]
Default: NULL

SQLPASSTHRU MODE	Specifies whether or not the BDE application will be able to access the SQL server via desktop queries and passthrough SQL queries in the same database alias connection. Can be NOT SHARED, SHARED AUTOCOMMIT, or SHARED NOAUTOCOMMIT. [more] Default: SHARED AUTOCOMMIT

TRACE MODE	A numeric value (bit mask) specifying how much trace information to log. The Windows OutputDebugString call is used to output the requested information to the debug window. The following table shows which information is logged based on bit settings:

Bit Settings	Logged Information

0x0001	prepared query statement

0x0002	executed query statements

0x0004	vendor errors

0x0008	statement options (that is: allocate, free)

0x0010	connect / disconnect

0x0020	transaction

0x0040	BLOB I/O

0x0080	miscellaneous

0x0100	vendor calls

ENABLE SCHEMA CACHE	Specifies whether the BDE caches table schema locally for tables residing on SQL servers. This enhances performance for table opens. Set SCHEMA CACHE DIR to the directory in which the local cache is stored.

SCHEMA CACHE TIME	Specifies how long table list information will be cached. (In the BDE, table information is cached when you call either DbiOpenTableList or DbiOpenFileList.) Setting this value can increase performance for table and file list retrieval. Possible modes and their meanings are listed here.

Setting	Meaning

-1	The table list is cached until you close the database. (Default)

0	No table lists are cached.

1 through 2147483647	The table list is cached for the number of seconds specified in the setting.

Default: -1

BATCH COUNT	Specifies the number of modified records to be included in a batch before auto-committing. In this way you can adjust the size of a batch to accommodate server transaction logs that are not big enough to handle the whole batch. In the BDE, you can override this value by setting the database property, dbBATCHCOUNT. See Borland Database Engine Online Reference

Default: The number of records that can fit into 32 KB

MAX ROWS

ROWSET SIZE	Specifies the number of rows to retrieve from the server in a single fetch, and the number of records to insert at a time when using DbiWriteBlock. This setting isn't supported by all ODBC drivers.

Default: 20 (20 records per server fetch, 20 records inserted at a a time).

ENABLE BCD	Specifies whether BDE translates numeric and decimal fields into floating point values or binary coded decimal (BCD) values. BCD values eliminate the rounding errors associated with floating point math (such as a 3 * (2/3) resulting in 2.00000000001). When ENABLE BCD is set to TRUE, DECIMAL and NUMERIC fields are converted to BCD for ODBC drivers.

BLOBS TO CACHE	Determines how many BLOBs will be cached on the client. Applications that deal with fetching dead BLOBs using dead table opens or queries can set a limit on the number of BLOBs to cache depending on the resource available on the client.

Setting a value of 100 means the application can work with a maximum of 100 BLOB records cached. Fetching more than 100, then scrolling back 100 records results in an "Invalid Blob handle in record buffer" error message. This parameter does not apply to live table opens. Default Value: 64, Range : >64 and < 65536.

BLOB SIZE	Determines the fetch buffer size for dead BLOBs. Applications that deal with dead BLOBs using dead  table opens or queries or batchmoves can set a maximum limit on the size of BLOBs to fetch. Setting this parameter to 64 means your application can fetch BLOBs of up to 64K. This parameter does not apply to live table opens. Default Value: 32, Range : >32 and <1000.


Sybase driver settings

If you have installed Borland SQL Links for Sybase, you can choose Sybase under Drivers in the left pane of the Configuration page in the BDE Administrator or can create or select a Sybase alias on the Databases page. The Sybase driver settings appear in the right pane. You cannot change those with bold labels.

For more information, see:

Connecting to Sybase

Sybase driver settings


Sybase driver setting jump


Oracle driver settings

If you have purchased and installed Borland SQL Links for Oracle, you can choose Oracle under Drivers in the left pane of the Configuration page in the BDE Administrator or can create or select an Oracle alias on the Databases page. The Oracle driver settings appear in the right pane. You cannot change those with bold labels.

For more information, see:

Connecting to Oracle

Oracle driver settings


Oracle driver setting jump


Informix driver settings

If you have purchased and installed Borland SQL Links for Informix, you can choose Informix under Drivers in the left pane of the Configuration page in the BDE Administrator or can create or select an Informix alias on the Databases page. The Informix driver settings appear in the right pane. You cannot change those with bold labels.

For more information, see:

Connecting to Informix

Informix driver settings


Informix driver setting jump


InterBase driver settings

If you have purchased and installed Borland SQL Links for InterBase, you can choose InterBase under Drivers in the left pane of the Configuration page in the BDE Administrator or can create or select an Interbase alias on the Databases page. The InterBase driver settings appear in the right pane. You cannot change those with bold labels.

For more information, see:

Connecting to InterBase

InterBase driver settings


InterBase driver setting jump


Microsoft SQL Server driver settings

If you have purchased and installed Borland SQL Links for Microsoft SQL Server, you can choose Microsoft SQL Server under Drivers in the left pane of the Configuration page in the BDE Administrator or can create or select an MSSQL alias on the Databases page. The Microsoft SQL Server driver settings appear in the right pane. You cannot change those with bold labels.

For more information, see:

Connecting to Microsoft SQL Server

Microsoft SQL Server driver settings


MS SQL driver setting jump


DB2 driver settings

If you have purchased and installed Borland SQL Links for DB2, you can choose DB2 under Drivers in the left pane of the Configuration page in the BDE Administrator or can create or select a DB2 alias on the Databases page. The DB2 driver settings appear in the right pane. You cannot change those with bold labels.

For more information, see:

Connecting to DB2

DB2 driver settings


DB2 driver setting jump


MAX ROWS

Specifies maximum number of rows that the SQL driver will attempt to fetch for every SQL statement sent to the server. This includes schema inquiry queries that the driver sends to the server during a table open to retrieve column, index, and valcheck information.

If a request is made for more than MAX ROWS, then an error is returned (DBIERR_ROWFETCHLIMIT). A return of DBIERR_ROWFETCHLIMIT is similar to DBIERR_EOF, except that it indicates a client-forced EOF when there actually may be more rows available on the server.

You can use the MAX ROWS option as a system governor to prevent users from unintentionally tying up valuable system resources. For example, a database administrator may set up users' configuration files to prevent them from tying up server and network resources if they happen to do a "SELECT * ..." on a huge table. You can set the MAX ROWS option make it impossible for a user to generate a million record query by mistake.

Be aware that if you set MAX ROWS too small, you may not be able to open a table under that database because it cannot get sufficient schema information. If MAX ROWS is not set to a large enough value to retrieve all the required metadata information during table open, then an error is returned and the table cannot be opened. MAX ROWS does not affect non-updateable queries in this way because a DESCRIBE (instead of a schema query) is used to get query column information.

Default:

 -1 (No limit on fetching rows.)

Warning!	A MAX ROW limitation could break existing BDE applications that fetch until receiving DBIERR_EOF. Such applications must be modified to handle a return of DBIERR_ROWFETCHLIMIT as well as DBIERR_EOF. Users should be able to "see" all rows that have already been fetched, but they should be notified that there may be additional rows on the server.


SQLQRYMODE settings

  Setting	 Meaning

NULL (blank setting)	(Default mode) Query goes first to the SQL server. If the server is unable to perform the query, it is performed at the Borland desktop.
SERVER	Query is sent to the SQL server. If the server is unable to perform the query, it fails.
LOCAL	Query is always performed at the desktop.


SQLPASSTHRU MODE settings

This parameter determines whether and how passthrough SQL and standard BDE calls share the same database connections.  For transactions, this translates to whether passthrough transactions and other transactions “know” about each other.

Only applications that use passthrough SQL need be concerned with SQLPASSTHRUMODE.  If you are developing an application to control transactions with passthrough SQL, you must set SQLPASSTHRU MODE to NOT SHARED.  Otherwise passthrough SQL and the application’s methods may interfere with each other, leading to unpredictable results.

  Setting	 Meaning

NOT SHARED  (blank setting)	Passthrough SQL and non-passthrough SQL do NOT share the same database connection.
SHARED AUTOCOMMIT	Passthrough SQL and non-passthrough SQL will share the same connection, and (as long as you are not in an explicit client transaction or batch mode) passthrough SQL will be automatically committed.  Each operation on a single row is committed.  This mode most closely approximates desktop database behavior but it is inefficient on SQL servers because it starts and commits a new transaction for each row, resulting in a heavy load of network traffic.
SHARED NOAUTOCOMMIT	Passthrough SQL and non-passthrough SQL share the same connection, but passthrough statements will not be automatically committed.  The application must explicitly start and commit transactions. This setting could result in conflicts in busy multi-user environments where many users are updating the same rows.


Paradox language drivers

Description

The following table shows the language drivers you can use for Paradox tables, along with the code page for each driver.

Note:	Internal language driver names are case-sensitive.

Long name	Internal name	Character set	Collation sequence
Paradox 'ascii'	ascii	DOS CODE PAGE 437	Binary
Paradox 'hebrew'	hebrew	DOS CODE PAGE 862	Hebrew
Paradox 'intl'	intl	DOS CODE PAGE 437	Multilingual Western Europe
Paradox 'intl' 850	intl850	DOS CODE PAGE 850	Brazilian Portuguese, French Canadian
Paradox 'japan'	japan	DOS CODE PAGE 932	Japanese
Paradox 'nordan'	nordan	DOS CODE PAGE 865	Norwegian/Danish (Paradox 3.5)
Paradox 'nordan40'	nordan40	DOS CODE PAGE 865	Norwegian/Danish (Paradox 4.0, 5.0, 5.5, 7.0)
Paradox 'swedfin'	swedfin	DOS CODE PAGE 437	Swedish/Finnish
Paradox 'turk'	turk		Turkish
Paradox ANSI HEBREW	ANHEBREW	1255(ANSI)	HebrewAnsi
Paradox China 936	china	DOS CODE PAGE 936	China
Paradox Cyrr 866	cyrr	DOS CODE PAGE 866	Cyrillic
Paradox Czech 852	czech	DOS CODE PAGE 852	Czech852
Paradox Czech 867	cskamen	DOS CODE PAGE 867	Czech867
Paradox ESP 437	SPANISH	DOS CODE PAGE 437	Spanish
Paradox Greek GR437	grcp437	DOS CODE PAGE 737	Greek
Paradox Hun 852 DC	hun852dc	DOS CODE PAGE 852	Hungarian
Paradox ISL 861	iceland	DOS CODE PAGE 861	Icelandic
Paradox Korea 949	korea	DOS CODE PAGE 949	Korea
Paradox Polish 852	polish	DOS CODE PAGE 852	Polish
Paradox Slovene 852	slovene	DOS CODE PAGE 852	Slovene
Paradox Taiwan 950	taiwan	DOS CODE PAGE 950	Taiwan
Paradox Thai 874	thai	DOS CODE PAGE 874	Thai
Pdox ANSI Chinese	ANCHINA
Pdox ANSI Cyrillic	ancyrr	1251 (ANSI)	Compatible with Paradox "cyrr"
Pdox ANSI Czech	anczech	1250 (ANSI)	Compatible with Paradox "czech"
Pdox ANSI Greek	angreek1	1253 (ANSI)	Compatible with Paradox "greek"
Pdox ANSI Hun. DC	anhundc	1250 (ANSI)	Compatible with Paradox "hung"
Pdox ANSI Intl	ANSIINTL	1252 (ANSI)	Compatible with Paradox "intl"
Pdox ANSI Intl850	ANSII850	DOS CODE PAGE 850	Compatible with Paradox "intl850"
Pdox ANSI Korean	ANKOREA
Pdox ANSI Nordan4	ANSINOR4	1252 (ANSI)	Compatible with Paradox "nordan40"
Pdox ANSI Polish	anpolish	1250(ANSI)	Compatible with Paradox "polish"
Pdox ANSI Slovene	ansislov	1250(ANSI)	Compatible with Paradox "slovene"
Pdox ANSI Spanish	ANSISPAN	1252(ANSI)	Compatible with Paradox "SPANISH"
Pdox ANSI Swedfin	ANSISWFN	1252(ANSI)	Compatible with Paradox "swedfin"
Pdox ANSI Taiwanese	ANTAIWAN
Pdox ANSI Thai	ANTHAI
Pdox ANSI Turkish	ANTURK	1254(ANSI)	Compatible with Paradox "turk"
pdx ANSI Czech 'CH'	anczechw	1250 (ANSI)
pdx Czech 852 'CH'	czechw	DOS CODE PAGE 852
pdx Czech 867 'CH'	cskamenw	DOS CODE PAGE 867
pdx ANSI ISO L_2 CZ	anil2czw	1250 (ANSI)	Paradox Czech, ISO8859-2 (ANSI)
pdx ISO L_2 Czech	il2czw	592	Paradox Czech, ISO8859-2


dBASE language drivers

Description

The following table shows the language drivers you can use for dBASE tables.

Note:	Internal language driver names are case-sensitive.

Long name	Internal name	Character set	Collation sequence
'ascii' ANSI	DBWINUS0	Windows CODE PAGE 1252	Binary
'Spanish' ANSI	DBWINES0	Windows CODE PAGE 1252	Spanish
'WEurope' ANSI	DBWINWE0	Windows CODE PAGE 1252	Multilingual Western Europe
dBASE CHS cp936	DB936CN0	DOS CODE PAGE 936	dBASE Chinese936
dBASE CSY cp852	DB852CZ0	DOS CODE PAGE 852	dBASE Czech852
dBASE CSY cp867	DB867CZ0	DOS CODE PAGE 867	dBASE Czech867
dBASE DAN cp865	DB865DA0	DOS CODE PAGE 865	dBASE Danish
dBASE DEU cp437	DB437DE0	DOS CODE PAGE 437	dBASE German
dBASE DEU cp850	DB850DE0	DOS CODE PAGE 850	dBASE German850
dBASE ELL GR437	db437gr0	DOS CODE PAGE 437	dBASE Greek
dBASE ENG cp437	DB437UK0	DOS CODE PAGE 437	dBASE English/UK
dBASE ENG cp850	DB850UK0	DOS CODE PAGE 850	dBASE English850/UK
dBASE ENU cp437	DB437US0	DOS CODE PAGE 437	dBASE English/US
dBASE ENU cp850	DB850US0	DOS CODE PAGE 850	dBASE English/US
dBASE ESP cp437	DB437ES1	DOS CODE PAGE 437	dBASE Spanish
dBASE ESP cp850	DB850ES0	DOS CODE PAGE 850	dBASE Spanish850
dBASE FIN cp437	DB437FI0	DOS CODE PAGE 437	dBASE Finnish
dBASE FRA cp437	DB437FR0	DOS CODE PAGE 437	dBASE French
dBASE FRA cp850	DB850FR0	DOS CODE PAGE 850	dBASE French850
dBASE FRC cp850	DB850CF0	DOS CODE PAGE 850	dBASE Canadian-French850
dBASE FRC cp863	DB863CF1	DOS CODE PAGE 863	dBASE Canadian-French863
dBASE HUN cp852	db852hdc	DOS CODE PAGE 852	dBASE Hungarian
dBASE ITA cp437	DB437IT0	DOS CODE PAGE 437	dBASE Italian
dBASE ITA cp850	DB850IT1	DOS CODE PAGE 850	dBASE Italian850
dBASE JPN Dic932	DB932JP1	DOS CODE PAGE 932	dBASE Japan Dic932
dBASE JPN cp932	DB932JP0	DOS CODE PAGE 932	dBASE Japan cp932
dBASE KOR cp949	DB949KO0	DOS CODE PAGE 949	dBASE Korea949
dBASE NLD cp437	DB437NL0	DOS CODE PAGE 437	dBASE Dutch
dBASE NLD cp850	DB850NL0	DOS CODE PAGE 850	dBASE Dutch850
dBASE NOR cp865	DB865NO0	DOS CODE PAGE 865	dBASE Norwegian
dBASE PLK cp852	db852po0	DOS CODE PAGE 852	dBASE Polish852
dBASE PTB cp850	DB850PT0	DOS CODE PAGE 850	dBASE Brazilian Portuguese 850
dBASE PTG cp860	DB860PT0	DOS CODE PAGE 860	dBASE Brazilian Portuguese 860
dBASE RUS cp866	db866ru0	DOS CODE PAGE 866	dBASE Russian
dBASE SLO cp852	db852sl0	DOS CODE PAGE 852
dBASE SVE cp437	DB437SV0	DOS CODE PAGE 437	dBASE Swedish
dBASE SVE cp850	DB850SV1	DOS CODE PAGE 850	dBASE Swedish850
dBASE CHT cp950	DB950TW0	DOS CODE PAGE 950	dBASE Taiwan950
dBASE THA cp874	db874th0	DOS CODE PAGE 874	dBASE Thai
dBASE TRK cp857	DB857TR0	DOS CODE PAGE 857	dBASE Turkish
Hebrew dBASE	dbHebrew		dBASE Hebrew


ODBC driver connection

A connection from your BDE application to an ODBC driver. The connection requires your BDE application, a vendor-supplied ODBC driver, and a BDE alias on the workstation side; an ODBC data source on the server side.

Once you create an ODBC driver connection, it appears on the list of available drivers on the Configuration page of the BDE Administrator. This lets you set up an alias for the target ODBC data source and connect to it through your BDE application.